<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
       <el-row style="margin-top: 3rem" >
         <el-col :offset="22" :span="2" > 
           <el-button size="medium" @click="editPage('edit')"  type="primary"> EDITAR </el-button>
          </el-col>
       </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title="String(itemSupportMat.originalTitle).toUpperCase()"  bgColor="background-color: #818181 !important"> </app-title>
    </div> 
    <section style="margin:0rem 6rem 4rem">
      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span > Total de Capítulos:  <br></span>                        
        </el-col>
        <el-col :span="12">
          <span>  {{ seasonFilterByTemp.chapters }} <br></span>
        </el-col>
      </el-row> 

      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span class="text-orange "> Capítulos Registrados: <br></span>                        
        </el-col>
        <el-col :span="12">
          <span class="text-orange "> {{ seasonFilterByTemp.registeredChapters }} </span>
        </el-col>
      </el-row> 

      <el-row style="margin:0 0 1rem 3rem" v-if="seasonFilterByTemp.observations">
        <el-col :span="16">
          <h3 style="margin: 3rem 0 2rem"> OBSERVACIONES </h3>
          <div class="bg-gray" style="padding: 1rem; width: 600px ">
            <p > {{ seasonFilterByTemp.observations }} </p>
         </div>
        </el-col>
      </el-row> 
    </section>

   <!-- TITULO DE LOS RANGOS  -->
    <div style="background-color: #fedbcc !important; color: #252525 !important; padding: 8px 20px; margin:3rem 6rem">
      <h3 class="text-bold"> <span class="bolt" style="margin-left: 10px" > {{ rangesCapsSelected }} </span> </h3> 
    </div>

      <!-- SELECT QUE FILTRA LOS RANGOS DE CAPITULOS  -->
    <div style="margin:3rem 6rem">
     <el-row :gutter="20">
        <el-col :span="6" :offset="18">
          <el-select @change="changeSeason(temporada)" v-model="temporada"  placeholder="rangos de capítulos" style="width: 100%">
            <el-option
            v-for="item in selectItems" 
            :key="item.value"
            :label="item.label"
            :value="item.value">
            </el-option>
          </el-select>  
        </el-col>  
      </el-row>
    </div>




   <section style="margin:0rem 5.5rem 5.5rem">
    	<el-table style="width: 100%"
          :data="rangesCapsDefaulChanges"
          :header-cell-class-name="tableRowClassName2"
          :row-class-name="tableRowClassName"
           border>
						<el-table-column
							label="CAPÍTULO" fixed>
							<template slot-scope="scope">
								<div class="chapterIndex">{{scope.row.chapter}}</div>
							</template>
						</el-table-column>
						<el-table-column
							label="TÍTULO GENERAL" >
							<template slot-scope="scope">
								{{ scope.row.titleChapter }}
							</template>
						</el-table-column>
						<el-table-column
							label="FECHA DE LLEGADA" >
							<template slot-scope="scope">
                	{{scope.row.arrivalDateString}}
							</template>
						</el-table-column>
						<el-table-column
							label="MODO DE ENVÍO" >
							<template slot-scope="scope">
                	{{scope.row.shippingMode}}
							</template>
						</el-table-column>
						<el-table-column
							label="SOPORTE" >
							<template slot-scope="scope">
                	{{scope.row.support}}
							</template>
						</el-table-column>
          	<el-table-column
							label="BLOQUES" >
							<template slot-scope="scope">
                	{{scope.row.numberBloques}}
							</template>
						</el-table-column>
          	<el-table-column
							label="BACK UP" >
							<template slot-scope="scope">
                	{{scope.row.copyBackUp}}
							</template>
						</el-table-column>
						<el-table-column
							label="DURACIÓN" >
							<template slot-scope="scope">
								<div v-if="scope.row.hourDuration !== undefined && scope.row.minDuration !== undefined && scope.row.secDuration !== undefined">
									{{scope.row.hourDuration}}h {{scope.row.minDuration}}min {{scope.row.secDuration}}s
								</div>
							</template>
						</el-table-column>
					</el-table>
    </section>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'  
import { HTTP } from '../../../main.js' 
import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'

  let count = 0
  
  export default {
    components: {
    ReturnButton,
    AppModalSuccess,
    AppModalDanger,
    'app-title': Title,
    'app-select': Select,
    'app-modal': AppModal
    },
    data() {
      return {
        idSupportMat: JSON.parse(this.$localStorage.get("idSupportMat")), 
        itemSupportMat: [],
        season: [],
        seasonFilterByTemp: [],
        selectItems: [],
        temporada: '',
        fusionGourmetSoporte: false,
        rangesCapsSelected : "",
        newArrChaptersRanges: [],
        rangesCapsDefaulChanges: []
      }
    },
    created() {     
      this.getSupportMaterials(); 
      this.fusionGourmetSoporte = this.$route.params.fusionGourmetSoporte
      console.log(this.fusionGourmetSoporte,'this.fusionGourmetSoporte')
    },
    methods: {
     editPage(text) {
      this.$localStorage.set('edit', JSON.stringify(text))
      if ( this.fusionGourmetSoporte === true ) {
        this.$router.push({ name: 'receptionMaterialsNac', params: { fusionGourmetSoporte: true } })
      }
      else {
        this.$router.push({ name: 'receptionMaterialsNac' })
      }
     },
     getSupportMaterials() {
      HTTP.get('materials/' + this.idSupportMat)
        .then(res => {
          this.itemSupportMat = res.data.material;
          this.season = res.data.material.numChapters
          this.seasonFilterByTemp = res.data.material.numChapters[0]
          this.selectFilterSeason();    
        })
        .catch(err => {
          console.log(err);
        });
      },

      selectFilterSeason() {
       this.selectItems = []
        if ( this.seasonFilterByTemp.infoByChapter.length > 100 ) {
          this.newArrChaptersRanges = []
          let divisionTotalCapAndCapsLimited = (this.seasonFilterByTemp.infoByChapter.length / 100)

          let endLimit = 100
          let startLimit = 0
          for (let i = 0; i < Math.round(divisionTotalCapAndCapsLimited); i++) {
            let capsFilter = this.seasonFilterByTemp.infoByChapter.filter( m => {
              return m.chapter <= endLimit && m.chapter > startLimit
            })
            
            let objt = {
              value: i,
              label: 'Capítulos del ' + capsFilter[0].chapter + ' al ' + capsFilter[capsFilter.length -1].chapter
            }

            this.selectItems.push(objt)
            this.newArrChaptersRanges.push(capsFilter)
            endLimit += 100
            startLimit += 100
          }
          this.rangesCapsSelected = this.selectItems[0].label
          this.rangesCapsDefaulChanges = this.newArrChaptersRanges[0]
        }
        else {
          let objt = {
            value: 0,
            label: 'caps. del 1 al ' + this.seasonFilterByTemp.infoByChapter.length
          }
          this.selectItems.push(objt)
          this.rangesCapsSelected = 'Capítulos del 1 al ' + this.seasonFilterByTemp.infoByChapter.length
          this.rangesCapsDefaulChanges = this.seasonFilterByTemp.infoByChapter
        }

        // count = 0
        // this.season.map((el, i, arr) => {
        //   let objt = {
        //     value: i,
        //     label: el.seasonString
        //   }
        //   this.selectItems.push(objt)
        // })  
      },
      changeSeason(temp) {
        this.rangesCapsDefaulChanges = []
        this.rangesCapsDefaulChanges = this.newArrChaptersRanges[temp]
        this.rangesCapsSelected = this.selectItems[temp].label
        // this.seasonFilterByTemp = []
        // this.seasonFilterByTemp = this.season[temp]
        this.indexTemp = temp
      },
      returnPage() {
        if ( this.fusionGourmetSoporte === true ) {
          this.$router.push({ name: 'fusionGourmetSoporte' })
        }
        else {
          this.$router.push({ name: 'nationalProduction' })
        } 
      },

      tableRowClassName2 ({row, rowIndex}) {
        if (rowIndex === 0) {
         return 'bg-gray';
        }
      },

      tableRowClassName ({row, rowIndex}) {

        if (rowIndex === 1) {
            count = 3
          return 'bg-color-nude';
        }
        if (rowIndex === count) {
            count += 2
          return 'bg-color-nude';
        }      
      },
      toggleDisplayTr({ row }) {
         if (true) {
          return 'success-row'
        }     
      }
    }
  }
</script>

<style>
  .el-table .success-row td:first-child {
    color: #ff5000 !important;
    font-weight: 700;
  }
</style>